/*******************************************************************************
 * Copyright (c) 2012 Guillaume Hillairet.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Guillaume Hillairet - initial API and implementation
 *******************************************************************************/
package org.eclipselabs.emfjson.junit.model;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Date;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>ETypes</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEString <em>EString</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEStrings <em>EStrings</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#isEBoolean <em>EBoolean</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEBooleans <em>EBooleans</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEInt <em>EInt</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEInts <em>EInts</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getDoubleValue <em>Double Value</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEDouble <em>EDouble</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEDoubles <em>EDoubles</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEBigDecimal <em>EBig Decimal</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEBigInteger <em>EBig Integer</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEByte <em>EByte</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEByteArray <em>EByte Array</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEChar <em>EChar</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEDate <em>EDate</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEFloat <em>EFloat</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getELong <em>ELong</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getEShort <em>EShort</em>}</li>
 *   <li>{@link org.eclipselabs.emfjson.junit.model.ETypes#getUris <em>Uris</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes()
 * @model
 * @generated
 */
public interface ETypes extends EObject {
	/**
	 * Returns the value of the '<em><b>EString</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EString</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EString</em>' attribute.
	 * @see #setEString(String)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EString()
	 * @model
	 * @generated
	 */
	String getEString();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getEString <em>EString</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EString</em>' attribute.
	 * @see #getEString()
	 * @generated
	 */
	void setEString(String value);

	/**
	 * Returns the value of the '<em><b>EStrings</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.String}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EStrings</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EStrings</em>' attribute list.
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EStrings()
	 * @model
	 * @generated
	 */
	EList<String> getEStrings();

	/**
	 * Returns the value of the '<em><b>EBoolean</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EBoolean</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EBoolean</em>' attribute.
	 * @see #setEBoolean(boolean)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EBoolean()
	 * @model
	 * @generated
	 */
	boolean isEBoolean();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#isEBoolean <em>EBoolean</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EBoolean</em>' attribute.
	 * @see #isEBoolean()
	 * @generated
	 */
	void setEBoolean(boolean value);

	/**
	 * Returns the value of the '<em><b>EBooleans</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.Boolean}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EBooleans</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EBooleans</em>' attribute list.
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EBooleans()
	 * @model
	 * @generated
	 */
	EList<Boolean> getEBooleans();

	/**
	 * Returns the value of the '<em><b>EInt</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EInt</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EInt</em>' attribute.
	 * @see #setEInt(int)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EInt()
	 * @model
	 * @generated
	 */
	int getEInt();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getEInt <em>EInt</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EInt</em>' attribute.
	 * @see #getEInt()
	 * @generated
	 */
	void setEInt(int value);

	/**
	 * Returns the value of the '<em><b>EInts</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.Integer}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EInts</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EInts</em>' attribute list.
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EInts()
	 * @model
	 * @generated
	 */
	EList<Integer> getEInts();

	/**
	 * Returns the value of the '<em><b>Double Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Double Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Double Value</em>' attribute.
	 * @see #setDoubleValue(Double)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_DoubleValue()
	 * @model
	 * @generated
	 */
	Double getDoubleValue();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getDoubleValue <em>Double Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Double Value</em>' attribute.
	 * @see #getDoubleValue()
	 * @generated
	 */
	void setDoubleValue(Double value);

	/**
	 * Returns the value of the '<em><b>EDouble</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EDouble</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EDouble</em>' attribute.
	 * @see #setEDouble(double)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EDouble()
	 * @model
	 * @generated
	 */
	double getEDouble();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getEDouble <em>EDouble</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EDouble</em>' attribute.
	 * @see #getEDouble()
	 * @generated
	 */
	void setEDouble(double value);

	/**
	 * Returns the value of the '<em><b>EDoubles</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.Double}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EDoubles</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EDoubles</em>' attribute list.
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EDoubles()
	 * @model
	 * @generated
	 */
	EList<Double> getEDoubles();

	/**
	 * Returns the value of the '<em><b>EBig Decimal</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EBig Decimal</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EBig Decimal</em>' attribute.
	 * @see #setEBigDecimal(BigDecimal)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EBigDecimal()
	 * @model
	 * @generated
	 */
	BigDecimal getEBigDecimal();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getEBigDecimal <em>EBig Decimal</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EBig Decimal</em>' attribute.
	 * @see #getEBigDecimal()
	 * @generated
	 */
	void setEBigDecimal(BigDecimal value);

	/**
	 * Returns the value of the '<em><b>EBig Integer</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EBig Integer</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EBig Integer</em>' attribute.
	 * @see #setEBigInteger(BigInteger)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EBigInteger()
	 * @model
	 * @generated
	 */
	BigInteger getEBigInteger();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getEBigInteger <em>EBig Integer</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EBig Integer</em>' attribute.
	 * @see #getEBigInteger()
	 * @generated
	 */
	void setEBigInteger(BigInteger value);

	/**
	 * Returns the value of the '<em><b>EByte</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EByte</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EByte</em>' attribute.
	 * @see #setEByte(byte)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EByte()
	 * @model
	 * @generated
	 */
	byte getEByte();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getEByte <em>EByte</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EByte</em>' attribute.
	 * @see #getEByte()
	 * @generated
	 */
	void setEByte(byte value);

	/**
	 * Returns the value of the '<em><b>EByte Array</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EByte Array</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EByte Array</em>' attribute.
	 * @see #setEByteArray(byte[])
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EByteArray()
	 * @model
	 * @generated
	 */
	byte[] getEByteArray();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getEByteArray <em>EByte Array</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EByte Array</em>' attribute.
	 * @see #getEByteArray()
	 * @generated
	 */
	void setEByteArray(byte[] value);

	/**
	 * Returns the value of the '<em><b>EChar</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EChar</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EChar</em>' attribute.
	 * @see #setEChar(char)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EChar()
	 * @model
	 * @generated
	 */
	char getEChar();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getEChar <em>EChar</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EChar</em>' attribute.
	 * @see #getEChar()
	 * @generated
	 */
	void setEChar(char value);

	/**
	 * Returns the value of the '<em><b>EDate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EDate</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EDate</em>' attribute.
	 * @see #setEDate(Date)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EDate()
	 * @model
	 * @generated
	 */
	Date getEDate();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getEDate <em>EDate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EDate</em>' attribute.
	 * @see #getEDate()
	 * @generated
	 */
	void setEDate(Date value);

	/**
	 * Returns the value of the '<em><b>EFloat</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EFloat</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EFloat</em>' attribute.
	 * @see #setEFloat(float)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EFloat()
	 * @model
	 * @generated
	 */
	float getEFloat();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getEFloat <em>EFloat</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EFloat</em>' attribute.
	 * @see #getEFloat()
	 * @generated
	 */
	void setEFloat(float value);

	/**
	 * Returns the value of the '<em><b>ELong</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>ELong</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>ELong</em>' attribute.
	 * @see #setELong(long)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_ELong()
	 * @model
	 * @generated
	 */
	long getELong();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getELong <em>ELong</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>ELong</em>' attribute.
	 * @see #getELong()
	 * @generated
	 */
	void setELong(long value);

	/**
	 * Returns the value of the '<em><b>EShort</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EShort</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EShort</em>' attribute.
	 * @see #setEShort(short)
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_EShort()
	 * @model
	 * @generated
	 */
	short getEShort();

	/**
	 * Sets the value of the '{@link org.eclipselabs.emfjson.junit.model.ETypes#getEShort <em>EShort</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>EShort</em>' attribute.
	 * @see #getEShort()
	 * @generated
	 */
	void setEShort(short value);

	/**
	 * Returns the value of the '<em><b>Uris</b></em>' attribute list.
	 * The list contents are of type {@link org.eclipse.emf.common.util.URI}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Uris</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Uris</em>' attribute list.
	 * @see org.eclipselabs.emfjson.junit.model.ModelPackage#getETypes_Uris()
	 * @model dataType="org.eclipselabs.emfjson.junit.model.URI"
	 * @generated
	 */
	EList<URI> getUris();

} // ETypes
